Phaneendra Manda | 4c62c80 | 2019-03-06 21:37:49 +0530 | [diff] [blame] | 1 | # |
| 2 | # Copyright 2016 the original author or authors. |
| 3 | # |
| 4 | # Licensed under the Apache License, Version 2.0 (the "License"); |
| 5 | # you may not use this file except in compliance with the License. |
| 6 | # You may obtain a copy of the License at |
| 7 | # |
| 8 | # http://www.apache.org/licenses/LICENSE-2.0 |
| 9 | # |
| 10 | # Unless required by applicable law or agreed to in writing, software |
| 11 | # distributed under the License is distributed on an "AS IS" BASIS, |
| 12 | # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| 13 | # See the License for the specific language governing permissions and |
| 14 | # limitations under the License. |
| 15 | # |
| 16 | |
Matt Jeanneret | 8b823f6 | 2019-05-11 11:01:28 -0400 | [diff] [blame] | 17 | # set default shell |
| 18 | SHELL = bash -e -o pipefail |
| 19 | |
| 20 | # Variables |
| 21 | VERSION ?= $(shell cat ./VERSION) |
| 22 | |
Matt Jeanneret | f880eb6 | 2019-07-16 20:08:03 -0400 | [diff] [blame] | 23 | DOCKER_LABEL_VCS_DIRTY = false |
| 24 | ifneq ($(shell git ls-files --others --modified --exclude-standard 2>/dev/null | wc -l | sed -e 's/ //g'),0) |
| 25 | DOCKER_LABEL_VCS_DIRTY = true |
| 26 | endif |
Matt Jeanneret | 8b823f6 | 2019-05-11 11:01:28 -0400 | [diff] [blame] | 27 | ## Docker related |
Matt Jeanneret | f880eb6 | 2019-07-16 20:08:03 -0400 | [diff] [blame] | 28 | DOCKER_EXTRA_ARGS ?= |
Matt Jeanneret | 8b823f6 | 2019-05-11 11:01:28 -0400 | [diff] [blame] | 29 | DOCKER_REGISTRY ?= |
| 30 | DOCKER_REPOSITORY ?= |
Matt Jeanneret | 8b823f6 | 2019-05-11 11:01:28 -0400 | [diff] [blame] | 31 | DOCKER_TAG ?= ${VERSION} |
Matt Jeanneret | b5bf10e | 2019-05-18 15:02:51 -0400 | [diff] [blame] | 32 | ADAPTER_IMAGENAME := ${DOCKER_REGISTRY}${DOCKER_REPOSITORY}voltha-openolt-adapter:${DOCKER_TAG} |
Andrea Campanella | cbf583e | 2019-12-17 15:26:00 -0800 | [diff] [blame] | 33 | TYPE ?= minimal |
Matt Jeanneret | 8b823f6 | 2019-05-11 11:01:28 -0400 | [diff] [blame] | 34 | |
| 35 | ## Docker labels. Only set ref and commit date if committed |
Matt Jeanneret | f880eb6 | 2019-07-16 20:08:03 -0400 | [diff] [blame] | 36 | DOCKER_LABEL_VCS_URL ?= $(shell git remote get-url $(shell git remote)) |
| 37 | DOCKER_LABEL_VCS_REF = $(shell git rev-parse HEAD) |
| 38 | DOCKER_LABEL_BUILD_DATE ?= $(shell date -u "+%Y-%m-%dT%H:%M:%SZ") |
| 39 | DOCKER_LABEL_COMMIT_DATE = $(shell git show -s --format=%cd --date=iso-strict HEAD) |
Matt Jeanneret | 8b823f6 | 2019-05-11 11:01:28 -0400 | [diff] [blame] | 40 | |
David Bainbridge | 788e520 | 2019-10-21 18:49:40 +0000 | [diff] [blame] | 41 | # Default is GO111MODULE=auto, which will refuse to use go mod if running |
| 42 | # go less than 1.13.0 and this repository is checked out in GOPATH. For now, |
| 43 | # force module usage. This affects commands executed from this Makefile, but |
| 44 | # not the environment inside the Docker build (which does not build from |
| 45 | # inside a GOPATH). |
| 46 | export GO111MODULE=on |
| 47 | |
Matt Jeanneret | f880eb6 | 2019-07-16 20:08:03 -0400 | [diff] [blame] | 48 | DOCKER_BUILD_ARGS ?= \ |
| 49 | ${DOCKER_EXTRA_ARGS} \ |
| 50 | --build-arg org_label_schema_version="${VERSION}" \ |
| 51 | --build-arg org_label_schema_vcs_url="${DOCKER_LABEL_VCS_URL}" \ |
| 52 | --build-arg org_label_schema_vcs_ref="${DOCKER_LABEL_VCS_REF}" \ |
| 53 | --build-arg org_label_schema_build_date="${DOCKER_LABEL_BUILD_DATE}" \ |
| 54 | --build-arg org_opencord_vcs_commit_date="${DOCKER_LABEL_COMMIT_DATE}" \ |
| 55 | --build-arg org_opencord_vcs_dirty="${DOCKER_LABEL_VCS_DIRTY}" |
| 56 | |
Scott Baker | 355d174 | 2019-10-24 10:57:52 -0700 | [diff] [blame] | 57 | .PHONY: docker-build local-protos local-lib-go |
Phaneendra Manda | 4c62c80 | 2019-03-06 21:37:49 +0530 | [diff] [blame] | 58 | |
| 59 | # This should to be the first and default target in this Makefile |
| 60 | help: |
| 61 | @echo "Usage: make [<target>]" |
| 62 | @echo "where available targets are:" |
David Bainbridge | 788e520 | 2019-10-21 18:49:40 +0000 | [diff] [blame] | 63 | @echo "" |
| 64 | @echo "clean : Removes any local filesystem artifacts generated by a build" |
| 65 | @echo "distclean : Removes any local filesystem artifacts generated by a build or test run" |
David Bainbridge | 63d5181 | 2019-10-22 15:55:29 +0000 | [diff] [blame] | 66 | @echo "build : Build all openolt adapter artifacts" |
Zack Williams | 95504be | 2019-09-03 14:17:24 -0700 | [diff] [blame] | 67 | @echo "docker-build : Build openolt adapter docker image" |
Matt Jeanneret | 8b823f6 | 2019-05-11 11:01:28 -0400 | [diff] [blame] | 68 | @echo "docker-push : Push the docker images to an external repository" |
David Bainbridge | 788e520 | 2019-10-21 18:49:40 +0000 | [diff] [blame] | 69 | @echo "help : Print this help" |
| 70 | @echo "lint : Run all lint targets" |
| 71 | @echo "lint-mod : Verify the Go dependencies" |
| 72 | @echo "lint-sanity : Run the Go language sanity tests (vet)" |
| 73 | @echo "lint-style : Verify the Go standard format of the source" |
| 74 | @echo "local-protos : Copies a local verison of the VOLTHA protos into the vendor directory" |
Scott Baker | 355d174 | 2019-10-24 10:57:52 -0700 | [diff] [blame] | 75 | @echo "local-lib-go : Copies a local version of the VOTLHA dependencies into the vendor directory" |
Girish Gowdru | 6a80bbd | 2019-07-02 07:36:09 -0700 | [diff] [blame] | 76 | @echo "sca : Runs various SCA through golangci-lint tool" |
Matt Jeanneret | 8b823f6 | 2019-05-11 11:01:28 -0400 | [diff] [blame] | 77 | @echo "test : Run unit tests, if any" |
Phaneendra Manda | 4c62c80 | 2019-03-06 21:37:49 +0530 | [diff] [blame] | 78 | @echo |
| 79 | |
Matt Jeanneret | b5bf10e | 2019-05-18 15:02:51 -0400 | [diff] [blame] | 80 | ## Local Development Helpers |
Phaneendra Manda | 4c62c80 | 2019-03-06 21:37:49 +0530 | [diff] [blame] | 81 | |
Matt Jeanneret | 8b823f6 | 2019-05-11 11:01:28 -0400 | [diff] [blame] | 82 | local-protos: |
William Kurkian | ea86948 | 2019-04-09 15:16:11 -0400 | [diff] [blame] | 83 | ifdef LOCAL_PROTOS |
William Kurkian | e4996f3 | 2019-11-13 15:47:43 -0500 | [diff] [blame] | 84 | rm -rf vendor/github.com/opencord/voltha-protos/v2/go |
| 85 | mkdir -p vendor/github.com/opencord/voltha-protos/v2/go |
| 86 | cp -r ${LOCAL_PROTOS}/go/* vendor/github.com/opencord/voltha-protos/v2/go |
| 87 | rm -rf vendor/github.com/opencord/voltha-protos/v2/go/vendor |
Matt Jeanneret | b5bf10e | 2019-05-18 15:02:51 -0400 | [diff] [blame] | 88 | endif |
| 89 | |
Scott Baker | 355d174 | 2019-10-24 10:57:52 -0700 | [diff] [blame] | 90 | ## Local Development Helpers |
| 91 | local-lib-go: |
| 92 | ifdef LOCAL_LIB_GO |
Scott Baker | 5e31207 | 2019-10-25 13:00:25 -0700 | [diff] [blame] | 93 | mkdir -p vendor/github.com/opencord/voltha-lib-go/v2/pkg |
| 94 | cp -r ${LOCAL_LIB_GO}/pkg/* vendor/github.com/opencord/voltha-lib-go/v2/pkg/ |
William Kurkian | ea86948 | 2019-04-09 15:16:11 -0400 | [diff] [blame] | 95 | endif |
Matt Jeanneret | 8b823f6 | 2019-05-11 11:01:28 -0400 | [diff] [blame] | 96 | |
Matt Jeanneret | b5bf10e | 2019-05-18 15:02:51 -0400 | [diff] [blame] | 97 | ## Docker targets |
| 98 | |
David Bainbridge | 63d5181 | 2019-10-22 15:55:29 +0000 | [diff] [blame] | 99 | build: docker-build |
| 100 | |
Scott Baker | 355d174 | 2019-10-24 10:57:52 -0700 | [diff] [blame] | 101 | docker-build: local-protos local-lib-go |
David K. Bainbridge | 8eb6cd6 | 2019-08-22 13:17:29 -0700 | [diff] [blame] | 102 | docker build $(DOCKER_BUILD_ARGS) -t ${ADAPTER_IMAGENAME} -f docker/Dockerfile.openolt . |
Matt Jeanneret | b5bf10e | 2019-05-18 15:02:51 -0400 | [diff] [blame] | 103 | |
Matt Jeanneret | 8b823f6 | 2019-05-11 11:01:28 -0400 | [diff] [blame] | 104 | docker-push: |
| 105 | docker push ${ADAPTER_IMAGENAME} |
| 106 | |
Andrea Campanella | cbf583e | 2019-12-17 15:26:00 -0800 | [diff] [blame] | 107 | docker-kind-load: |
| 108 | @if [ "`kind get clusters | grep voltha-$(TYPE)`" = '' ]; then echo "no voltha-$(TYPE) cluster found" && exit 1; fi |
| 109 | kind load docker-image ${ADAPTER_IMAGENAME} --name=voltha-$(TYPE) --nodes $(shell kubectl get nodes --template='{{range .items}}{{.metadata.name}},{{end}}' | sed 's/,$$//') |
| 110 | |
| 111 | |
Matt Jeanneret | 8b823f6 | 2019-05-11 11:01:28 -0400 | [diff] [blame] | 112 | ## lint and unit tests |
Phaneendra Manda | 4c62c80 | 2019-03-06 21:37:49 +0530 | [diff] [blame] | 113 | |
Matt Jeanneret | 384d8c9 | 2019-05-06 14:27:31 -0400 | [diff] [blame] | 114 | lint-style: |
| 115 | ifeq (,$(shell which gofmt)) |
| 116 | go get -u github.com/golang/go/src/cmd/gofmt |
| 117 | endif |
| 118 | @echo "Running style check..." |
| 119 | @gofmt_out="$$(gofmt -l $$(find . -name '*.go' -not -path './vendor/*'))" ;\ |
| 120 | if [ ! -z "$$gofmt_out" ]; then \ |
| 121 | echo "$$gofmt_out" ;\ |
| 122 | echo "Style check failed on one or more files ^, run 'go fmt' to fix." ;\ |
| 123 | exit 1 ;\ |
| 124 | fi |
| 125 | @echo "Style check OK" |
| 126 | |
| 127 | lint-sanity: |
| 128 | @echo "Running sanity check..." |
David Bainbridge | 788e520 | 2019-10-21 18:49:40 +0000 | [diff] [blame] | 129 | @go vet -mod=vendor ./... |
Matt Jeanneret | 384d8c9 | 2019-05-06 14:27:31 -0400 | [diff] [blame] | 130 | @echo "Sanity check OK" |
| 131 | |
David Bainbridge | 788e520 | 2019-10-21 18:49:40 +0000 | [diff] [blame] | 132 | lint-mod: |
Matt Jeanneret | 384d8c9 | 2019-05-06 14:27:31 -0400 | [diff] [blame] | 133 | @echo "Running dependency check..." |
David Bainbridge | 788e520 | 2019-10-21 18:49:40 +0000 | [diff] [blame] | 134 | @go mod verify |
Scott Baker | 22c0e9c | 2019-11-26 08:11:29 -0800 | [diff] [blame] | 135 | @echo "Dependency check OK. Running vendor check..." |
| 136 | @git status > /dev/null |
| 137 | @git diff-index --quiet HEAD -- go.mod go.sum vendor || (echo "ERROR: Staged or modified files must be committed before running this test" && echo "`git status`" && exit 1) |
| 138 | @[[ `git ls-files --exclude-standard --others go.mod go.sum vendor` == "" ]] || (echo "ERROR: Untracked files must be cleaned up before running this test" && echo "`git status`" && exit 1) |
| 139 | go mod tidy |
| 140 | go mod vendor |
| 141 | @git status > /dev/null |
| 142 | @git diff-index --quiet HEAD -- go.mod go.sum vendor || (echo "ERROR: Modified files detected after running go mod tidy / go mod vendor" && echo "`git status`" && exit 1) |
| 143 | @[[ `git ls-files --exclude-standard --others go.mod go.sum vendor` == "" ]] || (echo "ERROR: Untracked files detected after running go mod tidy / go mod vendor" && echo "`git status`" && exit 1) |
| 144 | @echo "Vendor check OK." |
Matt Jeanneret | 384d8c9 | 2019-05-06 14:27:31 -0400 | [diff] [blame] | 145 | |
David Bainbridge | 788e520 | 2019-10-21 18:49:40 +0000 | [diff] [blame] | 146 | lint: lint-style lint-sanity lint-mod |
| 147 | |
| 148 | __GOPATH=$(shell go env GOPATH) |
Matt Jeanneret | 384d8c9 | 2019-05-06 14:27:31 -0400 | [diff] [blame] | 149 | |
Scott Baker | a4cd50d | 2019-10-15 16:53:38 -0700 | [diff] [blame] | 150 | # Rules to automatically install golangci-lint |
| 151 | GOLANGCI_LINT_TOOL?=$(shell which golangci-lint) |
| 152 | ifeq (,$(GOLANGCI_LINT_TOOL)) |
David Bainbridge | 788e520 | 2019-10-21 18:49:40 +0000 | [diff] [blame] | 153 | GOLANGCI_LINT_TOOL=$(__GOPATH)/bin/golangci-lint |
Scott Baker | a4cd50d | 2019-10-15 16:53:38 -0700 | [diff] [blame] | 154 | golangci_lint_tool_install: |
| 155 | # Same version as installed by Jenkins ci-management |
| 156 | # Note that install using `go get` is not recommended as per https://github.com/golangci/golangci-lint |
David Bainbridge | 788e520 | 2019-10-21 18:49:40 +0000 | [diff] [blame] | 157 | curl -sfL https://raw.githubusercontent.com/golangci/golangci-lint/master/install.sh| sh -s -- -b $(__GOPATH)/bin v1.17.0 |
Scott Baker | a4cd50d | 2019-10-15 16:53:38 -0700 | [diff] [blame] | 158 | else |
| 159 | golangci_lint_tool_install: |
| 160 | endif |
| 161 | |
| 162 | # Rules to automatically install go-junit-report |
| 163 | GO_JUNIT_REPORT?=$(shell which go-junit-report) |
Matt Jeanneret | 384d8c9 | 2019-05-06 14:27:31 -0400 | [diff] [blame] | 164 | ifeq (,$(GO_JUNIT_REPORT)) |
David Bainbridge | 788e520 | 2019-10-21 18:49:40 +0000 | [diff] [blame] | 165 | GO_JUNIT_REPORT=$(__GOPATH)/bin/go-junit-report |
Scott Baker | a4cd50d | 2019-10-15 16:53:38 -0700 | [diff] [blame] | 166 | go_junit_install: |
Matt Jeanneret | 384d8c9 | 2019-05-06 14:27:31 -0400 | [diff] [blame] | 167 | go get -u github.com/jstemmer/go-junit-report |
Scott Baker | a4cd50d | 2019-10-15 16:53:38 -0700 | [diff] [blame] | 168 | else |
| 169 | go_junit_install: |
Matt Jeanneret | 384d8c9 | 2019-05-06 14:27:31 -0400 | [diff] [blame] | 170 | endif |
| 171 | |
Scott Baker | a4cd50d | 2019-10-15 16:53:38 -0700 | [diff] [blame] | 172 | # Rules to automatically install gocover-covertura |
| 173 | GOCOVER_COBERTURA?=$(shell which gocover-cobertura) |
Matt Jeanneret | 384d8c9 | 2019-05-06 14:27:31 -0400 | [diff] [blame] | 174 | ifeq (,$(GOCOVER_COBERTURA)) |
David Bainbridge | 788e520 | 2019-10-21 18:49:40 +0000 | [diff] [blame] | 175 | @GOCOVER_COBERTURA=$(__GOPATH)/bin/gocover-cobertura |
Scott Baker | a4cd50d | 2019-10-15 16:53:38 -0700 | [diff] [blame] | 176 | gocover_cobertura_install: |
| 177 | go get -u github.com/t-yuki/gocover-cobertura |
| 178 | else |
| 179 | gocover_cobertura_install: |
Matt Jeanneret | 384d8c9 | 2019-05-06 14:27:31 -0400 | [diff] [blame] | 180 | endif |
| 181 | |
Scott Baker | a4cd50d | 2019-10-15 16:53:38 -0700 | [diff] [blame] | 182 | test: go_junit_install gocover_cobertura_install |
Matt Jeanneret | 384d8c9 | 2019-05-06 14:27:31 -0400 | [diff] [blame] | 183 | @mkdir -p ./tests/results |
| 184 | |
David Bainbridge | 788e520 | 2019-10-21 18:49:40 +0000 | [diff] [blame] | 185 | @go test -mod=vendor -v -coverprofile ./tests/results/go-test-coverage.out -covermode count ./... 2>&1 | tee ./tests/results/go-test-results.out ;\ |
Matt Jeanneret | 384d8c9 | 2019-05-06 14:27:31 -0400 | [diff] [blame] | 186 | RETURN=$$? ;\ |
| 187 | $(GO_JUNIT_REPORT) < ./tests/results/go-test-results.out > ./tests/results/go-test-results.xml ;\ |
| 188 | $(GOCOVER_COBERTURA) < ./tests/results/go-test-coverage.out > ./tests/results/go-test-coverage.xml ;\ |
| 189 | exit $$RETURN |
| 190 | |
Girish Gowdru | 6a80bbd | 2019-07-02 07:36:09 -0700 | [diff] [blame] | 191 | GOLANGCI_LINT_TOOL:=$(shell which golangci-lint) |
Scott Baker | a4cd50d | 2019-10-15 16:53:38 -0700 | [diff] [blame] | 192 | sca: golangci_lint_tool_install |
Girish Gowdru | 6a80bbd | 2019-07-02 07:36:09 -0700 | [diff] [blame] | 193 | @mkdir -p ./sca-report |
David Bainbridge | 788e520 | 2019-10-21 18:49:40 +0000 | [diff] [blame] | 194 | golangci-lint run --out-format junit-xml ./... 2>&1 | tee ./sca-report/sca-report.xml |
Girish Gowdru | 6a80bbd | 2019-07-02 07:36:09 -0700 | [diff] [blame] | 195 | |
Matt Jeanneret | b5bf10e | 2019-05-18 15:02:51 -0400 | [diff] [blame] | 196 | clean: |
Matt Jeanneret | b5bf10e | 2019-05-18 15:02:51 -0400 | [diff] [blame] | 197 | |
| 198 | distclean: clean |
Scott Baker | a4cd50d | 2019-10-15 16:53:38 -0700 | [diff] [blame] | 199 | rm -rf ./sca_report |
Matt Jeanneret | b5bf10e | 2019-05-18 15:02:51 -0400 | [diff] [blame] | 200 | |
Phaneendra Manda | 4c62c80 | 2019-03-06 21:37:49 +0530 | [diff] [blame] | 201 | # end file |